//CNC router
//
//Code to run on the command computer see:
//commands-plotter.c
//
//Source & info: www.HomoFaciens.de


//#include <avr/io.h>
//#include <util/delay.h>
#include <Servo.h> 

//Change values below to adapt your CNC

#define STEP_MARGIN 3L            //10 - 1000 (2)
#define SERVO_MAX_L    170          //0 - 180 (125)
#define SERVO_MAX_R     10          //0 - 180 (125)
#define SERVO_MIN_LX   110          //0 - 180 (125)
#define SERVO_MIN_RX    70          //0 - 180 (125)
#define SERVO_MIN_LY   115          //0 - 180 (125)
#define SERVO_MIN_RY    60          //0 - 180 (125)

#define SERVO_Z 11                 //Servo Z axis

#define SERVO_Y_SENSOR_1 A2       //Sensor input 1
#define SERVO_Y_SENSOR_2 A3       //Sensor input 2
#define SERVO_Y 10                //Servo Y axis

#define SERVO_X_SENSOR_1 A0       //Sensor input 1
#define SERVO_X_SENSOR_2 A1       //Sensor input 2
#define SERVO_X 9                //Servo X axis

#define RELAY 8          //Relay used to turn on milling machine

Servo ServoZ;
Servo ServoY;
Servo ServoX;

int ServoZSetPoint = 90;

int ServoYSensor02 = 0;
int ServoYSensor01 = 0;
unsigned long ServoYSetPoint = 0;
unsigned long ServoYIsPoint = 0;
byte ServoYStep = 0;
byte ServoYStepDone = 0;

int ServoXSensor02 = 0;
int ServoXSensor01 = 0;
int ServoLX = SERVO_MAX_L; // 10 - 180
int ServoRX = SERVO_MAX_R; // 10 - 180
int ServoLY = SERVO_MAX_L; // 10 - 180
int ServoRY = SERVO_MAX_R; // 10 - 180
unsigned long ServoXSetPoint = 0;
unsigned long ServoXIsPoint = 0;
byte ServoXStep = 0;
byte ServoXStepDone = 0;


byte readByte = 0;


unsigned long stepTime = 1;

unsigned long millisStart = 0;


void establishContact() {
  while (Serial.available() <= 0) {
    Serial.print('X');   // send a capital X
    delay(300);
  }
}

void setup(){ 

  pinMode(RELAY, OUTPUT);
  digitalWrite(RELAY, 0);
  
  pinMode(SERVO_Y_SENSOR_1, INPUT);
  pinMode(SERVO_Y_SENSOR_2, INPUT);
    
  pinMode(SERVO_X_SENSOR_1, INPUT);
  pinMode(SERVO_X_SENSOR_2, INPUT);

  stepTime = 1;
  readByte = 0;
  
  ServoZSetPoint = 90;
  ServoZ.attach(SERVO_Z);
  ServoZ.write(ServoZSetPoint);

  ServoYStep = 0;
  ServoXStep = 0;

  ServoYStepDone = 1;
  ServoXStepDone = 1;
  
  ServoYSetPoint = 300000;
  ServoYIsPoint  = 300000;

  ServoXSetPoint = 300000;
  ServoXIsPoint =  300000;

  // start serial port at 115200 bps:
  Serial.begin(115200);
  establishContact();  // send a byte to establish contact until receiver responds 
}


void loop(){  

  millisStart = millis();
  while(millis() - millisStart < stepTime){
    do{

      ServoYSensor01 = digitalRead(SERVO_Y_SENSOR_1);
      ServoYSensor02 = digitalRead(SERVO_Y_SENSOR_2);
    
      if(ServoYSensor02 == 0 && ServoYSensor01 == 0){
        if(ServoYStep == 1){
          ServoYIsPoint--;
        }
        if(ServoYStep == 3){
          ServoYIsPoint++;
        }
        ServoYStep = 0;
      }
    
      if(ServoYSensor02 == 1 && ServoYSensor01 == 0){
        if(ServoYStep == 0){
          ServoYIsPoint++;
        }
        if(ServoYStep == 2){
          ServoYIsPoint--;
        }
        ServoYStep = 1;
      }
    
      if(ServoYSensor02 == 1 && ServoYSensor01 == 1){
        if(ServoYStep == 3){
          ServoYIsPoint--;
        }
        if(ServoYStep == 1){
          ServoYIsPoint++;
        }
        ServoYStep = 2;
      }
    
      if(ServoYSensor02 == 0 && ServoYSensor01 == 1){
        if(ServoYStep == 2){
          ServoYIsPoint++;
        }
        if(ServoYStep == 0){
          ServoYIsPoint--;
        }
        ServoYStep = 3;
      }

      if(abs(ServoYSetPoint - ServoYIsPoint) < STEP_MARGIN){
        ServoY.detach();
        ServoYStepDone = 1;
        ServoLY=SERVO_MIN_LY;
        ServoRY=SERVO_MIN_RY;
      }
      else{
        if(ServoYIsPoint < ServoYSetPoint){
          ServoY.attach(SERVO_Y);
          ServoY.write(ServoLY);
        }
        if(ServoYIsPoint > ServoYSetPoint){
          ServoY.attach(SERVO_Y);        
          ServoY.write(ServoRY);
        }
      }

      ServoXSensor01 = digitalRead(SERVO_X_SENSOR_1);
      ServoXSensor02 = digitalRead(SERVO_X_SENSOR_2);
    
      if(ServoXSensor02 == 0 && ServoXSensor01 == 0){
        if(ServoXStep == 1){
          ServoXIsPoint--;
        }
        if(ServoXStep == 3){
          ServoXIsPoint++;
        }
        ServoXStep = 0;
      }
    
      if(ServoXSensor02 == 1 && ServoXSensor01 == 0){
        if(ServoXStep == 0){
          ServoXIsPoint++;
        }
        if(ServoXStep == 2){
          ServoXIsPoint--;
        }
        ServoXStep = 1;
      }
    
      if(ServoXSensor02 == 1 && ServoXSensor01 == 1){
        if(ServoXStep == 3){
          ServoXIsPoint--;
        }
        if(ServoXStep == 1){
          ServoXIsPoint++;
        }
        ServoXStep = 2;
      }
    
      if(ServoXSensor02 == 0 && ServoXSensor01 == 1){
        if(ServoXStep == 2){
          ServoXIsPoint++;
        }
        if(ServoXStep == 0){
          ServoXIsPoint--;
        }
        ServoXStep = 3;
      }

      if(abs(ServoXSetPoint - ServoXIsPoint) < STEP_MARGIN){
        ServoX.detach();
        ServoXStepDone = 1;
        ServoLX=SERVO_MIN_LX;
        ServoRX=SERVO_MIN_RX;
      }
      else{
        if(ServoXIsPoint < ServoXSetPoint){
          ServoX.attach(SERVO_X);
          ServoX.write(ServoLX);
        }
        if(ServoXIsPoint > ServoXSetPoint){
          ServoX.attach(SERVO_X);
          ServoX.write(ServoRX);
        }
      }

      
    }while(ServoYStepDone == 0 || ServoXStepDone == 0);
    if(readByte == 0){
      millisStart = 0L;
    }
  }//while(millis() - millisStart < stepTime){
  
  readByte = 0;
  if (Serial.available() > 0){//if we get a valid byte, read from serial:
    //get incoming byte:
    readByte = Serial.read();
    Serial.print('r');   // send a 'r' to initiate next data from computer
  }//if (Serial.available() > 0){


  
  if(readByte > 0){
    if(readByte == 255){
      digitalWrite(RELAY, 1);
      readByte = 0;
    }
    if(readByte == 254){
      digitalWrite(RELAY, 0);
      readByte = 0;
    }

    if(readByte == 128){
      if(stepTime < 1000){
        stepTime+=10;
      }
    }
    if(readByte == 64){
      if(stepTime > 10){
        stepTime-=10;
      }
    }
    if(readByte == 32){
      if(ServoZSetPoint > 0){
        ServoZSetPoint--;
      }
      ServoZ.write(ServoZSetPoint);
    }
    if(readByte == 16){
      if(ServoZSetPoint < 180){
        ServoZSetPoint++;
      }
      ServoZ.write(ServoZSetPoint);
    }
    if(readByte == 8){
      ServoYSetPoint++;
      ServoLY=SERVO_MAX_L;
      ServoRY=SERVO_MAX_R;
      ServoYStepDone = 0;
    }
    if(readByte == 4){
      ServoYSetPoint--;
      ServoLY=SERVO_MAX_L;
      ServoRY=SERVO_MAX_R;
      ServoYStepDone = 0;
    }
    if(readByte == 2){
      ServoXSetPoint++;
      ServoLX=SERVO_MAX_L;
      ServoRX=SERVO_MAX_R;
      ServoXStepDone = 0;
    }
    if(readByte == 1){
      ServoXSetPoint--;
      ServoLX=SERVO_MAX_L;
      ServoRX=SERVO_MAX_R;
      ServoXStepDone = 0;
    }
      
  }//if(readByte > 0){

}


